FSYNC(2)

NAME
fsync - synchronize a file's in-core state with that on disk

SYNOPSIS
#include <unistd.h>
int
fsync(int fildes);

DESCRIPTION
Fsync() causes all modified data and attributes of fildes to be moved to a permanent storage device. This normally results in all in-core modified copies of buffers for the associated file to be written to a disk.

Note that while fsync() will flush all data from the host to the drive (i.e. the "permanent storage device"), the drive itself may not physically write the data to the platters for quite some time and it may be written in an out-of-order sequence.

Specifically, if the drive loses power or the OS crashes, the application may find that only some or none of their data was written. The disk drive may also re-order the data so that later writes may be present, while earlier writes are not.

This is not a theoretical edge case. This scenario is easily reproduced with real world workloads and drive power failures.

For applications that require tighter guarantees about the integrity of their data, Mac OS X provides the F_FULLFSYNC fcntl. The F_FULLFSYNC fcntl asks the drive to flush all buffered data to permanent storage. Applications, such as databases, that require a strict ordering of writes should use F_FULLFSYNC to ensure that their data is written in the order they expect. Please see fcntl(2) for more detail.

RETURN VALUES

ERRORS
The fsync() system call will fail if:

[EBADF]
    fildes is not a valid descriptor.

[EINTR]
    Its execution is interrupted by a signal.

[EINVAL]
    fildes refers to a file type (e.g., a socket) that does not support this operation.

[EIO]
    An I/O error occurred while reading from or writing to the file system.

If a queued I/O operation fails, fsync() may fail with any of the errors defined for read(2) or write(2).

SEE ALSO
fcntl(2), read(2), sync(2), write(2), sync(8), update(8)

HISTORY
The fsync() function call appeared in 4.2BSD.